# example build command: kversion=2.6.27.21-170.2.56.fc10 kvariants='"" PAE' make rpm

%{!?project_version:%define project_version 1.30}
%{!?svn_rev:%define svn_rev 3079}

%define is_fedora %(test -e /etc/fedora-release && echo 1 || echo 0)
%define is_rhel4 %(test -f /etc/redhat-release && cat /etc/redhat-release | egrep -q 'release 4' && echo 1 || echo 0)
%define is_rhel5 %(test -f /etc/redhat-release && cat /etc/redhat-release | egrep -q 'release 5' && echo 1 || echo 0)

%if %is_fedora
%{!?kversion: %define kversion %(uname -r|sed s/\.`uname -m`//)}
%else
%{!?kversion: %define kversion %(uname -r|sed -e 's/\(PAE\|xenU\|xen\|smp\|hugemem\)//g')}
%endif

%define has_kmodtool %(test -e /usr/lib/rpm/redhat/kmodtool && echo 1 || echo 0)
Source10: kmodtool2
%if %has_kmodtool
%define kmodtool %{-s*}%{!-s:/usr/lib/rpm/redhat/kmodtool}
%else
%define kmodtool bash %{SOURCE10}
%endif

%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%if %is_rhel4
%define upvar ""
%define xenvar xenU
%define PAEvar hugemem
%endif

%if %is_rhel5
%define upvar ""
%define xenvar xen
%ifarch i686
%define PAEvar PAE
%endif
%endif

%if %is_fedora
%define xenvar xen
%ifarch i686
%define PAEvar PAE
%endif
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}
# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 


Name: mlink
Summary: %{name} kernel modules
Version: %{project_version}
Release: 4.%{svn_rev}
License: GPL
Group: System Environment/Kernel
URL: http://afi.jinr.ru/mlink
Source0: %{name}-kmod-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: redhat-rpm-config >= 8.0.32
ExclusiveArch:  i586 i686 x86_64
PreReq: %{name}-utils

%description
M-Link is a custom communication interface based on packet structure like
Ethernet. It is used with ADCM, VMEDAQ projects.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
for kvariant in %{kvariants} ; do
    cp -a %{name}-kmod-%{version} _kmod_build_${kvariant}
    pushd _kmod_build_$kvariant
    popd
done


%build
for kvariant in %{kvariants}
do
    pushd _kmod_build_$kvariant
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
%if %is_fedora
    ksrc=%{_usrsrc}/kernels/%{kverrel}%{_target_cpu}${kvariant:+.$kvariant}
%else
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
%endif
    pushd _kmod_build_$kvariant
	pushd driver
	make install \
  		NODEBUG=yes svn_rev=%{svn_rev} \
  		KDIR=${ksrc} \
  		MOD_DESTDIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{name}
    popd
	popd
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{name}/*
mkdir -p $RPM_BUILD_ROOT/lib/firmware

%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Wed May 13 2009  <Ilja.Slepnev@jinr.ru> - 
- Fixed package name

* Tue May 12 2009  <Ilja.Slepnev@jinr.ru> - 
- Split in two packages: mlink and mlink-kmod

* Wed Apr 22 2009  <Ilja.Slepnev@jinr.ru> - 
- 1.30: build with kmodtool2. Package name changed: mlink-utils, mlink-kmod

* Mon Apr 20 2009  <Ilja.Slepnev@jinr.ru> - 
- removed mlink.ko file. use melink.ko

* Wed Apr 08 2009  <Ilja.Slepnev@jinr.ru> - 
- 1.29: Removed special run-mode. Packet mode only.

* Tue Mar 25 2009  <Ilja.Slepnev@jinr.ru> - 
- Fixed communication problem caused by receiver_reset() in RXC handler
- testlink: Fixed clock locking problem when changing loopback mode

* Tue Mar  3 2009  <Ilja.Slepnev@jinr.ru> - 
- Changed version to 1.28
- Added MlinkDevice interface class

* Thu Feb 12 2009  <Ilja.Slepnev@jinr.ru> - 
- Added control frame loopback bit

* Thu Dec 11 2008  <Ilja.Slepnev@jinr.ru> - 
- Handle link up/down status on reset, use OSD bit

* Thu Nov 28 2008  <Ilja.Slepnev@jinr.ru> - 
- defined 'kdir' macro
- fixed x86_64 warnings

* Thu Nov 27 2008  <Ilja.Slepnev@jinr.ru> - 
- spec file corrected to build on Fedora 10.

* Tue Nov 18 2008  <Ilja.Slepnev@jinr.ru> - 
- Initial build.

